unit units;
{***************************************************************************}
                                  interface
{***************************************************************************}
const
  Cv = 720;
  Cvn = 800;
var
  boot_record, boot_loader: array[1..512] of byte;

procedure GetAbsSector(Disk,Head: Byte; CSec: Word; var Buf);
{⠥ ᮫ ᪮ ᥪ   뢠 $13}
procedure GetMasterBoot(var Buf);
{頥  ६ Buf  㧮 ᥪ}
procedure SetMasterBoot(var Buf);
{뢠   㧮 ᥪ ᮤন Buf}
procedure CursorOff;
{㡨ࠥ   ⥪⮢ ०}
procedure CursorOn;
{砥   ⥪⮢ ०}
procedure Ramka(x1,y1,x2,y2,t,c: byte);
{ ࠬ 梥⮬ c; t - ⨯ ࠬ: 1 - ୠ, 2 - ;
x1,y1 - 孨  㣮, x2,y2 -  ࠢ 㣮}
procedure WindowCreate(x1,y1,x2,y2: byte; text: string; ram,txt,typ: byte);
{ᮧ ;
x1,y1 - न  孥 㣫, x2,y2 - ࠢ ;
text -  ; ram - 梥 ࠬ; txt - 梥 ⥪;
typ - ⨯ ࠬ ((2)  ୠ(1));}
procedure Shadow(x,y,w:integer;ct,ft,c:integer);
{ࠡ  ;
x,y - 砫 न; w - ; ct - 梥 ⥪; ft - 梥 䮭;
c -  ⥪   (1/0)}
function KeyCode: word;
{頥  ⮩ }

{***************************************************************************}
                             implementation
{***************************************************************************}
uses dos,crt;
const
  lines: array [1..12] of char = ('-', '', '', '', '', '', '', '', '', '','', '');


procedure CursorOff;assembler; {㡨ࠥ   ⥪⮢ ०}
    asm
      mov   ah,1
      mov   cx,2020h   { 栭  । }
      int   10h
    end;{CursorOff}
{---------------------------------------------------------------------------}
procedure CursorOn;assembler;  {砥   ⥪⮢ ०}
    asm
      mov   ah,1
      mov   cx,0607h   {⠭ 栭 6  7 ப}
      int   10h
    end;{CursorOn}
{---------------------------------------------------------------------------}
procedure GetAbsSector(Disk,Head: Byte; CSec: Word; var Buf);
var
  Reg: registers;
begin
 with Reg do
   begin
     ah := 2;           { ⥭}
     dl := Disk;        { ਢ}
     dh := Head;        { }
     cx := CSec;        {/ᥪ}
     al := 1;           {  ᥪ}
     es := seg(Buf);
     bx := ofs(Buf);
     Intr($13,Reg)
   end
end; {GetAbsSector}
{---------------------------------------------------------------------------}
procedure GetMasterBoot(var Buf);
begin
 GetAbsSector($80,0,1,Buf)
end; {GetMasterBoot}
{---------------------------------------------------------------------------}
procedure Ramka(x1,y1,x2,y2,t,c: byte);
var
  x,y,i: byte;
  g1,g2,g3,g4,g5,g6: char;
begin
  x:= x1;
  y:= y1;
  case t of
    1: begin
         g1:= lines[5];
         g2:= lines[1];
         g3:= lines[6];
         g4:= lines[2];
         g5:= lines[7];
         g6:= lines[8]
       end;
    2: begin
         g1:= lines[9];
         g2:= lines[3];
         g3:= lines[10];
         g4:= lines[4];
         g5:= lines[11];
         g6:= lines[12]
       end
  end;
  TextColor(c);
  GoToXY(x1,y1);
  Write(g1);
  for i:= 1 to (x2-x1-1) do
    Write(g2);
  Write(g3);
  for i:= 1 to (y2-y1-1) do
    begin
      GoToXY(x2,y1+i);
      Write(g4)
    end;
  GoToXY(x1,y2);
  Write(g6);
  for i:= 1 to (x2-x1-1) do
    Write(g2);
  Write(g5);
  GoToXY(x1,y1);
  for i:= 1 to (y2-y1-1) do
    begin
      GoToXY(x1,y1+i);
      Write(g4)
    end
end;{Ramka}
{---------------------------------------------------------------------------}
procedure SetMasterBoot(var Buf);
var
  Reg: registers;
begin
 with Reg do
   begin
     ah := 3;             { }
     al := 1;             {- ᥪ஢}
     dl := $80;           {1- ⪨ }
     dh := 0;             { 0}
     cx := 1;             {1- ᥪ 0- ஦}
     es := seg(Buf);
     bx := ofs(Buf);
     Intr($13, Reg)
   end
end; {SetMasterBoot}
{---------------------------------------------------------------------------}
procedure WindowCreate(x1,y1,x2,y2: byte; text: string;
                       ram,txt,typ: byte);
var
  x,y: byte; {⥪騥 न}
  LastAttr: byte;
begin
  LastAttr:= TextAttr;
  x:= x1;
  y:= y1;
  Ramka(x1,y1,x2,y2,typ,ram);
  TextColor(txt);
  if text<>'' then
    text:= ' ' + text + ' ';
  if (length(text)+2)<(x2-x1) then
    begin
      y:= y1;
      x:= x1 + ((x2-x1) div 2) - (length(text) div 2) + 1;
      GoToXY(x,y);
      Write(text)
    end;
  TextAttr:= LastAttr
end;{WindowCreate}
{---------------------------------------------------------------------------}
procedure Shadow(x,y,w:integer;ct,ft,c:integer);
var
  l,i:integer;
  attr:byte;
begin
  attr:=ct+16*ft;
  x:= x-1;
  if lastmode=co40 then l:=y*80+2*x+1;
  if lastmode=co80 then l:=y*160+2*x+1;
  i:=l;
  if c=0 then
    while (i<l+2*w) do
      begin
        mem[$b800:i]:=attr;
        i:=i+2
      end
  else
    while (i<l+2*w) do
      begin
        mem[$b800:i-1]:= $20;
        mem[$b800:i]:=attr;
        i:=i+2
      end
end;{Shadow}
{---------------------------------------------------------------------------}
function KeyCode: word;
var
  c: char;
begin
  while keypressed do readkey;
  c:= Readkey;
  if c<>#0 then
    KeyCode:= ord(c)
  else
    KeyCode:= ord(ReadKey) * 10
end;{KeyCode}
{---------------------------------------------------------------------------}
var
  i: word;
begin
  for i:= 0 to 512 do
    begin
      boot_record[i]:= 0;
      boot_loader[i]:= 0
    end
end.
