use16
org 7C00h

start:
      cld		      ;   (   )
      mov ax, cs
      mov ds, ax
      mov es, ax
      mov si, 7C00h	      ; 
      mov di, 7E00h	      ; 
      mov cx, 200h	      ; 
      REP movsb 	      ;

      mov ax, 3 	      ;     
      int 10h

      call Detect_OS	;   

Case:
      call InSymbol
      cmp  al, '1'
      je diskett
      sub al, 32h
      mov bl, 10h
      mul bl
      mov bx, 01BEh
      mov ax, bx
      jmp hdd

diskett:
      mov cx, 0003h
      mov ax, cs
      mov es, ax
retry_floppy_read:
      push cx
      mov ax, 0201h
      mov bx, 7C00h
      mov cx, 0001h
      xor dx, dx
      int 13h
      pop cx
      loop retry_floppy_read
      jc Error
      jmp go

find_boot:
      mov si, 7E00h + 01BEh
read_next:
      cmp byte[si], 80h
      jz end_find
      add si, 10h
      cmp si, 7E00h+01FEh
      jnz read_next
end_read:
      call Error
end_find:
      sub si, 7E00h
      mov ax, si

hdd:
      push ax
;  HDD
      mov ah, 00h
      mov dl, 80h
      int 13h
      jc Error

      pop ax
      add ax, 7E00h
      mov di, ax
      mov cx, 3
retry_hdd_read:
      mov byte [dap], 16   ; 
      mov byte [dap+02h],1 ;  
      mov di, ax  ;;;;?
      mov word [dap+06h], 0   ; 
      mov eax, [di+08h]
      mov dword [dap+08h], eax
      mov ah, 42h
      mov word [dap+04h], 7C00h  ; 
      mov si, dap
      mov dl, 80h
      mov bp, 7C00h
      int 13h
      loop retry_hdd_read
      jnc go
      jmp Error

;   boot-
go:
      jmp 0000:7C00h

Error:
      mov dx,0803h
      mov cx,5
      mov bp, error_msg
      call OutString
reboot:
      jmp reboot
      ret

InSymbol:
; al   
      push bx
      mov [timer], 0
      mov bx, timer
      mov ah, 83h
      xor al, al
      mov cx, 004Ch
      mov dx, 4B40h
      int 15h
      mov ah, 11h
repeat_in:
      cmp [timer], 10000000b
      je default
      int 16h
      jz repeat_in
      jmp no_default
default:
      jmp find_boot
no_default:
      push ax
      mov ah, 83h
      mov al, 01h
      int 15h
      pop ax
      pop bx
      ret

OutSymbol:
; al ,  bl 
      pusha
      call SetCursor
      mov ah, 09h
      xor bh, bh
      mov bl, 0Ah
      int 10h
      popa
      ret

SetCursor:
; dh ,  dl 
      mov ah, 02h
      xor bh, bh
      int 10h
      ret

OutString:
;cx  ,  bp  ,  dh ,  dl 
      pusha
      mov ax, 1300h
      mov bx, 000Ah
      int 10h
      popa
      ret

Detect_OS:
      mov dx,0202h
      mov cx, 8
      mov bp, floppy
      call OutString

      mov al, 31h
      xor ah, ah
      mov di, 7E00h+01C2h
      mov dh, 02h
      mov cx, 4
OS_print:
      push cx
      add al, 01h
      add dh, 01h
      mov dl, 02h
      call OutSymbol
      mov cx, 1
      mov dl, 03h
      mov bp, msg
      call OutString
      mov bl, [di]
      add di, 10h
      mov dl, 04h
      cmp bl, 00h
      jz none_os
      cmp bl, 0Bh   ;FAT32 CHS
      jz  fat_disk
      cmp bl, 0Ch   ;FAT32 LBA
      jz  fat_disk

      mov cx, 7
      mov bp, os_unknown
      jmp os_end_case

fat_disk:
      mov cx, 5
      mov bp, fat32
      jmp os_end_case

none_os:
      mov cx, 4
      mov bp, os_none
os_end_case:
      call OutString
      pop cx
      loop OS_print

      mov cx, 1
      mov dx, 0802h
      mov bp, prompt
      call OutString
      mov dx, 0803h
      call SetCursor
      ret

floppy db "1-Floppy"
error_msg db "Error";
msg db "-"
os_none     db "None"
os_unknown  db "Unknown"
fat32	    db "FAT32"
prompt db ">"
dap rb 16
timer db 0